/////////////////////////////////////////////////////////////////////////////
//		TrUtl.c

#include	<windows.h>
#include	<commctrl.h>
#include	"util.h"
#include	"TrUtl.h"
#include	"resource.h"


////////////////////////////////////////////////////////////
//	錾

//萔
#define			APPNAME			_T("TrUtl")
#define			CLASSNAME		_T("TrUtlClass")
#define			WM_TASKTRAY		(WM_APP+100)
#define			IDM_IDLERELEASE	(49999)

//ϐ
HINSTANCE		g_hInst		= NULL;
TTRYICON		g_tTryIcon	= {0};
TTRYALRM		g_tTryAlrm	= {0};
SYSTEMTIME		g_tTime		= {0};

//֐
BOOL	InitCpuUsage( void );
BOOL	ExitCpuUsage( void );
DWORD	GetCpuUsage( void );
INT		GetServerTime( SYSTEMTIME*, TCHAR*, SHORT );


////////////////////////////////////////////////////////////
//	IvV

//IvV̓Ǎ
BOOL ReadOption( TOPTION* pOption )
{
	TCHAR	szFile[MAX_PATH];
	TCHAR	szBuff[32767];
	TCHAR	*pStr;
	BYTE	byCount;

	GetModuleFileName( g_hInst, szFile, MAX_PATH );
	lstrcpy( lstrrchr(szFile,'.'), _T(".ini") );

	pOption->tTryIcon.bEnable	= 1;
	pOption->tTryIcon.nMode		= GetPrivateProfileInt( _T("IconTray")    , _T("Mode")    ,        1, szFile );
	pOption->tTryIcon.nCpuIdle	= GetPrivateProfileInt( _T("IconTray")    , _T("CpuIdle") ,        5, szFile );
	pOption->tTryIcon.nCpuTime	= GetPrivateProfileInt( _T("IconTray")    , _T("CpuTime") ,       30, szFile );
							   GetPrivateProfileString( _T("IconTray")    , _T("NTP")     ,   _T(""), pOption->tTryIcon.szNTP, 64, szFile );

	pOption->tWndGrid.bEnable	= GetPrivateProfileInt( _T("WindowGrid")  , _T("Enable")  ,        1, szFile );
	pOption->tWndGrid.nInterval	= GetPrivateProfileInt( _T("WindowGrid")  , _T("Interval"),       16, szFile );
	pOption->tWndGrid.nPauseKey	= GetPrivateProfileInt( _T("WindowGrid")  , _T("PauseKey"), VK_SHIFT, szFile );

	pOption->tMouScrl.bEnable	= GetPrivateProfileInt( _T("MouseScroll") , _T("Enable")  ,        1, szFile );
	pOption->tMouScrl.nSense	= GetPrivateProfileInt( _T("MouseScroll") , _T("Sense")   ,       16, szFile );
	pOption->tMouScrl.nPlayKey	= GetPrivateProfileInt( _T("MouseScroll") , _T("PlayKey") , VK_SHIFT, szFile );

	pOption->tSelTask.bEnable	= GetPrivateProfileInt( _T("SelectTask")  , _T("Enable")  ,        1, szFile );
	pOption->tSelTask.bToolWnd	= GetPrivateProfileInt( _T("SelectTask")  , _T("ToolWnd") ,        0, szFile );

	pOption->tTryAlrm.bEnable	= GetPrivateProfileInt( _T("TrayAlarm")   , _T("Enable")  ,        0, szFile );
							  GetPrivateProfileSection( _T("TrayAlarm")   ,szBuff         ,    32767, szFile );
	for( pStr = szBuff, byCount = 0; *pStr && byCount < 64; ++pStr )
	{
		if( lstrcmpn(pStr, _T("Enable"), 6) ) {
			lstrcpyn( pOption->tTryAlrm.szMsg[byCount], pStr, 64 );
			pOption->tTryAlrm.szMsg[byCount][5] = _T(' ');
			++byCount;
		}
		pStr += lstrlen(pStr);
	}
	pOption->tTryAlrm.byCount		= byCount;

	return	TRUE;
}

//IvV̕ۑ
BOOL SaveOption( TOPTION* pOption )
{
	TCHAR	szFile[MAX_PATH];
	TCHAR	szBuff[32767];
	TCHAR	*pStr;
	BYTE	byCount;

	GetModuleFileName( g_hInst, szFile, MAX_PATH );
	lstrcpy( lstrrchr(szFile,'.'), _T(".ini") );

	WritePrivateProfileInt   ( _T("IconTray")    , _T("Mode")    , pOption->tTryIcon.nMode    , szFile );
	WritePrivateProfileInt   ( _T("IconTray")    , _T("CpuIdle") , pOption->tTryIcon.nCpuIdle , szFile );
	WritePrivateProfileInt   ( _T("IconTray")    , _T("CpuTime") , pOption->tTryIcon.nCpuTime , szFile );
	WritePrivateProfileString( _T("IconTray")    , _T("NTP")     , pOption->tTryIcon.szNTP    , szFile );

	WritePrivateProfileInt   ( _T("WindowGrid")  , _T("Enable")  , pOption->tWndGrid.bEnable  , szFile );
	WritePrivateProfileInt   ( _T("WindowGrid")  , _T("Interval"), pOption->tWndGrid.nInterval, szFile );
	WritePrivateProfileInt   ( _T("WindowGrid")  , _T("PauseKey"), pOption->tWndGrid.nPauseKey, szFile );

	WritePrivateProfileInt   ( _T("MouseScroll") , _T("Enable")  , pOption->tMouScrl.bEnable  , szFile );
	WritePrivateProfileInt   ( _T("MouseScroll") , _T("Sense")   , pOption->tMouScrl.nSense   , szFile );
	WritePrivateProfileInt   ( _T("MouseScroll") , _T("PlayKey") , pOption->tMouScrl.nPlayKey , szFile );

	WritePrivateProfileInt   ( _T("SelectTask")  , _T("Enable")  , pOption->tSelTask.bEnable  , szFile );
	WritePrivateProfileInt   ( _T("SelectTask")  , _T("ToolWnd") , pOption->tSelTask.bToolWnd , szFile );

	ZeroMemory( szBuff, sizeof(szBuff) );
	pStr	= szBuff;
	wsprintf( pStr, _T("Enable=%d"), pOption->tTryAlrm.bEnable);
	pStr += lstrlen(pStr) + 1;
	for( byCount = 0; byCount < pOption->tTryAlrm.byCount; ++byCount )
	{
		pOption->tTryAlrm.szMsg[byCount][5] = _T('=');
		lstrcpy( pStr, pOption->tTryAlrm.szMsg[byCount] );
		pStr += lstrlen(pStr) + 1;
	}
	WritePrivateProfileSection( _T("TrayAlarm"), szBuff, szFile );

	return	TRUE;
}

//IvṼ_CAO
BOOL CALLBACK OptionDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			TOPTION	tOption;
			BYTE	byCount;

			InitKeyScanButton( GetDlgItem(hDlg,IDC_WGCHKKEY) );
			InitKeyScanButton( GetDlgItem(hDlg,IDC_MSCHKKEY) );

			ReadOption( &tOption );

			if     ( tOption.tTryIcon.nMode == 0 )	SetDlgItemCheck( hDlg, IDC_TIOPTNOR, BST_CHECKED );
			else if( tOption.tTryIcon.nMode == 1 )	SetDlgItemCheck( hDlg, IDC_TIOPTCLK, BST_CHECKED );
			else if( tOption.tTryIcon.nMode == 2 )	SetDlgItemCheck( hDlg, IDC_TIOPTCPU, BST_CHECKED );

			SetDlgItemInt  ( hDlg, IDC_TITXTIDLE , tOption.tTryIcon.nCpuIdle, FALSE );
			SetDlgItemInt  ( hDlg, IDC_TITXTTIME , tOption.tTryIcon.nCpuTime, FALSE );
			SetDlgItemText ( hDlg, IDC_TITXTNTP  , tOption.tTryIcon.szNTP           );

			SetDlgItemCheck( hDlg, IDC_WGCHK     , tOption.tWndGrid.bEnable?BST_CHECKED:BST_UNCHECKED );
			SetDlgItemInt  ( hDlg, IDC_WGTXTINT  , tOption.tWndGrid.nInterval, FALSE );
			SetDlgItemVKey ( hDlg, IDC_WGCHKKEY  , tOption.tWndGrid.nPauseKey        );

			SetDlgItemCheck( hDlg, IDC_MSCHK     , tOption.tMouScrl.bEnable?BST_CHECKED:BST_UNCHECKED );
			SetDlgItemInt  ( hDlg, IDC_MSTXTSENSE, tOption.tMouScrl.nSense, FALSE );
			SetDlgItemVKey ( hDlg, IDC_MSCHKKEY  , tOption.tMouScrl.nPlayKey      );

			SetDlgItemCheck( hDlg, IDC_STCHK     , tOption.tSelTask.bEnable?BST_CHECKED:BST_UNCHECKED );
			SetDlgItemCheck( hDlg, IDC_STCHKTOOL , tOption.tSelTask.bToolWnd?BST_CHECKED:BST_UNCHECKED );

			SetDlgItemCheck( hDlg, IDC_CHKALARM  , tOption.tTryAlrm.bEnable?BST_CHECKED:BST_UNCHECKED );
			SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_RESETCONTENT, 0, 0 );
			for( byCount = 0; byCount < tOption.tTryAlrm.byCount; ++byCount ) {
				SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_ADDSTRING, 0, (LPARAM)tOption.tTryAlrm.szMsg[byCount] );
			}
			SendDlgItemMessage( hDlg, IDC_TXTHOUR, EM_SETLIMITTEXT,  2, 0 );
			SendDlgItemMessage( hDlg, IDC_TXTMIN , EM_SETLIMITTEXT,  2, 0 );
			SendDlgItemMessage( hDlg, IDC_TXTMSG , EM_SETLIMITTEXT, 58, 0 );
		}
		return	TRUE;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDC_BTNADD:
			{
				INT		hour, min;
				TCHAR	msg[256], buf[256];
				GetDlgItemText( hDlg, IDC_TXTHOUR, msg, 256 );	hour= lston(msg);
				GetDlgItemText( hDlg, IDC_TXTMIN , msg, 256 );	min	= lston(msg);
				GetDlgItemText( hDlg, IDC_TXTMSG , msg, 256 );
				wsprintf( buf, _T("%02d:%02d %s"), hour, min, msg );
				SendDlgItemMessage( hDlg,IDC_LSTMSG,LB_ADDSTRING,0,(LPARAM)buf );
			}
			return	TRUE;
		case IDC_BTNMOD:
			{
				INT		hour, min;
				TCHAR	msg[256], buf[256];
				DWORD	n = SendDlgItemMessage( hDlg, IDC_LSTMSG ,LB_GETCURSEL, 0, 0 );
				if( n == -1 )	break;
				SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_DELETESTRING, n, 0 );
				GetDlgItemText( hDlg, IDC_TXTHOUR, msg, 256 );	hour= lston(msg);
				GetDlgItemText( hDlg, IDC_TXTMIN , msg, 256 );	min	= lston(msg);
				GetDlgItemText( hDlg, IDC_TXTMSG , msg, 256 );
				wsprintf( buf, _T("%02d:%02d %s"), hour, min, msg );
				SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_ADDSTRING, 0, (LPARAM)buf );
			}
			return	TRUE;
		case IDC_BTNDEL:
			{
				DWORD	n = SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_GETCURSEL, 0, 0 );
				if( n == -1 )	break;
				SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_DELETESTRING, n, 0 );
			}
			return	TRUE;
		case IDC_LSTMSG:
			if( HIWORD(wParam) == LBN_SELCHANGE )
			{
				DWORD	n;
				TCHAR	msg[256], buf[256];
				n = SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_GETCURSEL, 0, 0 );
				SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_GETTEXT, n, (LPARAM)msg );
				lstrcpyn( buf, msg  , 3 );	SetDlgItemText( hDlg, IDC_TXTHOUR, buf );
				lstrcpyn( buf, msg+3, 3 );	SetDlgItemText( hDlg, IDC_TXTMIN , buf );
				lstrcpy ( buf, msg+6    );	SetDlgItemText( hDlg, IDC_TXTMSG , buf );
			}
			return	TRUE;

		case IDOK:
			{
				TOPTION	tOption;
				BYTE	byCount;

				tOption.tTryIcon.bEnable	= 1;
				if     ( GetDlgItemCheck(hDlg,IDC_TIOPTNOR) )	tOption.tTryIcon.nMode = 0;
				else if( GetDlgItemCheck(hDlg,IDC_TIOPTCLK) )	tOption.tTryIcon.nMode = 1;
				else if( GetDlgItemCheck(hDlg,IDC_TIOPTCPU) )	tOption.tTryIcon.nMode = 2;
				tOption.tTryIcon.nCpuIdle	= GetDlgItemInt( hDlg, IDC_TITXTIDLE, NULL, FALSE );
				tOption.tTryIcon.nCpuTime	= GetDlgItemInt( hDlg, IDC_TITXTTIME, NULL, FALSE );
				GetDlgItemText( hDlg, IDC_TITXTNTP, tOption.tTryIcon.szNTP, 64 );

				tOption.tWndGrid.bEnable	= GetDlgItemCheck( hDlg, IDC_WGCHK                   );
				tOption.tWndGrid.nInterval	= GetDlgItemInt  ( hDlg, IDC_WGTXTINT  , NULL, FALSE );
				tOption.tWndGrid.nPauseKey	= GetDlgItemVKey ( hDlg, IDC_WGCHKKEY                );

				tOption.tMouScrl.bEnable	= GetDlgItemCheck( hDlg, IDC_MSCHK                   );
				tOption.tMouScrl.nSense		= GetDlgItemInt  ( hDlg, IDC_MSTXTSENSE, NULL, FALSE );
				tOption.tMouScrl.nPlayKey	= GetDlgItemVKey ( hDlg, IDC_MSCHKKEY                );

				tOption.tSelTask.bEnable	= GetDlgItemCheck( hDlg, IDC_STCHK                   );
				tOption.tSelTask.bToolWnd	= GetDlgItemCheck( hDlg, IDC_STCHKTOOL               );

				tOption.tTryAlrm.bEnable	= GetDlgItemCheck( hDlg, IDC_CHKALARM                );
				tOption.tTryAlrm.byCount	= (BYTE)SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_GETCOUNT, 0,0 );
				for( byCount = 0; byCount < tOption.tTryAlrm.byCount; ++byCount ) {
					SendDlgItemMessage( hDlg, IDC_LSTMSG, LB_GETTEXT ,byCount, (LPARAM)tOption.tTryAlrm.szMsg[byCount] );
				}

				SaveOption( &tOption );
			}
			EndDialog( hDlg, TRUE );
			return	TRUE;

		case IDCANCEL:
			EndDialog( hDlg, FALSE );
			return	TRUE;
		}
		break;
	}

	return	FALSE;
}
//
BOOL OptionDialog( HWND hWnd )
{
	return	DialogBox( g_hInst, MAKEINTRESOURCE(IDD_OPTION), hWnd, OptionDlgProc );
}


////////////////////////////////////////////////////////////
//	gCACR

//ϐ
NOTIFYICONDATA	nid		= {0};
HIMAGELIST		hImgClk	= NULL;
HIMAGELIST		hImgCpu	= NULL;
HMENU			hMenu	= NULL;

//\[Xǂݍ
LPCTSTR GetString( UINT uID )
{
	static UINT		s_uID	= -1;
	static TCHAR	szBuff[128];

	if (s_uID == uID )
		return	szBuff;
	s_uID = uID;

	if( LoadString( g_hInst, uID, szBuff, 128 ) )
		return	szBuff;
	else
		return	NULL;
}

//bZ[W̕\
BOOL DisplayMessage( LPCTSTR szMsg )
{
#if 0
	typedef struct _NOTIFYICONDATA2 { 
		DWORD	cbSize; 
		HWND	hWnd; 
		UINT	uID; 
		UINT	uFlags; 
		UINT	uCallbackMessage; 
		HICON	hIcon; 
		TCHAR	szTip[128];
		DWORD	dwState;
		DWORD	dwStateMask;
		TCHAR	szInfo[256];
		union {
			UINT	uTimeout;
			UINT	uVersion;
		} DUMMYUNIONNAME;
		TCHAR	szInfoTitle[64];
		DWORD	dwInfoFlags;
	} NOTIFYICONDATA2;

	NOTIFYICONDATA2	nid2;

	nid2.cbSize			= sizeof(NOTIFYICONDATA2);
	nid2.uID			= nid.uID;
	nid2.hWnd			= nid.hWnd;
	nid2.uFlags			= 0x10;	//NIF_INFO
	nid2.dwInfoFlags	= 0;	//NIIF_NONE
	nid2.uTimeout		= 30000;
	lstrcpy(nid2.szInfoTitle, APPNAME);
	lstrcpy(nid2.szInfo     , szMsg  );

	Shell_NotifyIcon( NIM_MODIFY, (NOTIFYICONDATA *)&nid2 );
#else
	MessageBox( nid.hWnd, szMsg, APPNAME, MB_OK|MB_TOPMOST );
#endif

	return	TRUE;
}

//I
BOOL WindowsExit( UINT uType )
{
	HANDLE				hToken = NULL;
	TOKEN_PRIVILEGES	tp;

	//NT̏Ig[N擾
	OpenProcessToken( GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &hToken );
	LookupPrivilegeValue( NULL, SE_SHUTDOWN_NAME, &tp.Privileges[0].Luid );
	tp.PrivilegeCount			= 1;
	tp.Privileges[0].Attributes	= SE_PRIVILEGE_ENABLED;
	AdjustTokenPrivileges( hToken, FALSE, &tp, 0, NULL, NULL );

	//I
	switch( uType )
	{
	case 0:		ExitWindowsEx( EWX_POWEROFF, 0 );		break;
	case 1:		ExitWindowsEx( EWX_SHUTDOWN, 0 );		break;
	case 2:		ExitWindowsEx( EWX_REBOOT  , 0 );		break;
	case 3:		ExitWindowsEx( EWX_LOGOFF  , 0 );		break;
	case 4:		SetSystemPowerState( FALSE, FALSE );	break;	//nCo[l[V
	case 5:		SetSystemPowerState( TRUE , FALSE );	break;	//TXyh
	}

	//NT̏Ig[NJ
	if( hToken )
	{
		tp.Privileges[0].Attributes	= 0;
		AdjustTokenPrivileges( hToken, FALSE, &tp, 0, NULL, NULL );
		CloseHandle( hToken );
	}

	return	TRUE;
}

//tbN
BOOL HookIconTrayTimer( HWND hWnd, UINT nID, TIMERPROC* lpTimerProc )
{
	static	BYTE		nIdle	= 0;
	static	BYTE		nOld	= 0;
	static	BYTE		nAlarm	= 0;
			BYTE		nNum;
			HIMAGELIST	hImg, hImg2;

	if     ( g_tTryIcon.nMode == 0 )	//ʏ\
	{
		if( nID == -1 ) {
			nid.uFlags	= NIF_ICON | NIF_TIP;
			nid.hIcon	= LoadIcon( g_hInst, MAKEINTRESOURCE(IDI_MAIN) );
			lstrcpy( nid.szTip, APPNAME );
			Shell_NotifyIcon( NIM_MODIFY, &nid );
		}
	}
	else if( g_tTryIcon.nMode == 1 )	//\
	{
		nNum	= g_tTime.wHour*60 + g_tTime.wMinute;

		if( nNum != nOld || nID == -1 ) {
			wsprintf( nid.szTip, GetString(IDS_TIPCLK),
				g_tTime.wYear,g_tTime.wMonth,g_tTime.wDay, g_tTime.wHour,g_tTime.wMinute );
			hImg		= ImageList_Merge( hImgClk,g_tTime.wHour, hImgClk,(g_tTime.wMinute/10)+24, 0,0 );
			nid.hIcon	= ImageList_GetIcon( hImg, 0, ILD_NORMAL );
			nid.uFlags	= NIF_TIP | NIF_ICON;
			Shell_NotifyIcon( NIM_MODIFY, &nid );
			DestroyIcon( nid.hIcon );
			ImageList_Destroy( hImg );
			nOld		= nNum;
		}
	}
	else if( g_tTryIcon.nMode == 2 )	//CPU\
	{
		MEMORYSTATUSEX	ms;
		ZeroMemory( &ms, sizeof(MEMORYSTATUSEX) );
		ms.dwLength = sizeof(MEMORYSTATUSEX);
		GlobalMemoryStatusEx( &ms );
		nNum	= (BYTE)GetCpuUsage();

		if( nNum != nOld || nID == -1 ) {
			wsprintf( nid.szTip, GetString(IDS_TIPCPU),
				(int)((ms.ullTotalPageFile-ms.ullAvailPageFile)>>20), (int)(ms.ullTotalPageFile>>20) );
			hImg		= ImageList_Merge( hImgCpu,nNum/10, hImgCpu,(nNum%10)+11, 0,0 );
			nid.hIcon	= ImageList_GetIcon( hImg, 0, ILD_NORMAL );
			nid.uFlags	= NIF_TIP | NIF_ICON;
			Shell_NotifyIcon( NIM_MODIFY, &nid );
			DestroyIcon( nid.hIcon );
			ImageList_Destroy( hImg );
			nOld		= nNum;
		}
	}
	else if( g_tTryIcon.nMode & 0xF0 )	//IDLE\
	{
		nNum	= (BYTE)GetCpuUsage();
		if( nNum > 99 )	nNum = 99;

		if( nNum >= g_tTryIcon.nCpuIdle || nID == -1 )
			nIdle	= g_tTryIcon.nCpuTime;
		else if( --nIdle == 0 ) {
			PostMessage( hWnd, WM_COMMAND, IDM_IDLERELEASE, 0 );
			if( g_tTryIcon.nMode & 0x10 )	PostMessage( hWnd, WM_COMMAND, IDM_WINSHUTDOWN, 0 );
			if( g_tTryIcon.nMode & 0x20 )	PostMessage( hWnd, WM_COMMAND, IDM_WINSTANDBY , 0 );
		}

		if( nNum != nOld || nID == -1 )
		{
			hImg2		= ImageList_Merge( hImgCpu,nNum/10, hImgCpu,(nNum%10)+11, 0,0 );
			hImg		= ImageList_Merge( hImg2,0, hImgCpu,((nIdle-1)*6/g_tTryIcon.nCpuTime)+21, 0,0 );
			nid.hIcon	= ImageList_GetIcon( hImg, 0, ILD_NORMAL );
			if( g_tTryIcon.nMode & 0x10 )	wsprintf( nid.szTip, GetString(IDS_IDSHUTDOWN), nIdle );
			if( g_tTryIcon.nMode & 0x20 )	wsprintf( nid.szTip, GetString(IDS_IDSTANDBY ), nIdle );
			nid.uFlags	= NIF_ICON | NIF_TIP;
			Shell_NotifyIcon( NIM_MODIFY, &nid );
			DestroyIcon( nid.hIcon );
			ImageList_Destroy( hImg );
			ImageList_Destroy( hImg2 );
			nOld		= nNum;
		}
	}

	if( g_tTryAlrm.bEnable )
	{
		nNum	= g_tTime.wHour*60 + g_tTime.wMinute;
		if( nAlarm != nNum || nID == -1 )
		{
			TCHAR	szMsg[64];
			BYTE	byCount;
			INT		nLoop;
			nAlarm	= nNum;
			wsprintf( szMsg, _T("%02d:%02d"), g_tTime.wHour,g_tTime.wMinute );
			for( byCount = 0; byCount < g_tTryAlrm.byCount; ++byCount ) {
				if( lstrcmpn(szMsg,g_tTryAlrm.szMsg[byCount],5) == 0 ) {
					lstrcpy( szMsg, &g_tTryAlrm.szMsg[byCount][6] );
					for( nLoop = 0; szMsg[nLoop]; ++nLoop ) {
						if( szMsg[nLoop] == '|' ) szMsg[nLoop] = '\n';
						if( IsLegal(&szMsg[nLoop]) ) ++nLoop;
					}
					DisplayMessage( szMsg );
				}
			}
		}
	}

	return	TRUE;
}
//
BOOL HookIconTrayTaskTray( HWND hWnd, UINT wID, UINT uMsg )
{
	switch( uMsg )
	{
	case WM_RBUTTONDOWN:
		if( g_tTryIcon.nMode & 0xF0 )
			PostMessage( hWnd, WM_COMMAND, IDM_IDLERELEASE, 0 );
		else {
			BOOL	bAct;
			POINT	pt;
			SystemParametersInfo( SPI_GETSCREENSAVEACTIVE, 0, &bAct, 0 );
			EnableMenuItem( hMenu, IDM_SCRNSAVE, bAct?MF_ENABLED:MF_DISABLED|MF_GRAYED );
			EnableMenuItem( hMenu, IDM_NTPSERVER, g_tTryIcon.szNTP[0]?MF_ENABLED:MF_DISABLED|MF_GRAYED );
			GetCursorPos( &pt );
			SetForegroundWindow( hWnd );
			TrackPopupMenu( hMenu, TPM_BOTTOMALIGN|TPM_LEFTALIGN|TPM_RIGHTBUTTON, pt.x,pt.y, 0, hWnd, NULL );
			PostMessage( hWnd, WM_NULL, 0, 0 );
		}
		break;
	}

	return	TRUE;
}
//
BOOL HookIconTrayCommand( HWND hWnd, WORD wCode, WORD wID, HWND hCtrl )
{
	switch( wID )
	{
	case IDM_EXIT:
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
		break;
	case IDM_OPTION:
		if( OptionDialog( hWnd ) ) {
			TOPTION	tOption;
			ReadOption( &tOption );
			SetExeHook( TRUE, &tOption );
			SetDllHook( TRUE, &tOption );
			HookIconTrayTimer( hWnd, -1, NULL );
		}
		break;

	case IDM_WINSHUTDOWN:
		WindowsExit( 0 );
		break;
	case IDM_WINREBOOT:
		WindowsExit( 2 );
		break;
	case IDM_WINSTANDBY:
		WindowsExit( 5 );
		break;
	case IDM_WINLOGOFF:
		WindowsExit( 3 );
		break;

	case IDM_IDLESHUTDOWN:
		g_tTryIcon.nMode = g_tTryIcon.nMode & 0x0F | 0x10;
		HookIconTrayTimer( hWnd, -1, NULL );
		break;
	case IDM_IDLESTANDBY:
		g_tTryIcon.nMode = g_tTryIcon.nMode & 0x0F | 0x20;
		HookIconTrayTimer( hWnd, -1, NULL );
		break;
	case IDM_IDLERELEASE:
		g_tTryIcon.nMode = g_tTryIcon.nMode & 0x0F;
		HookIconTrayTimer( hWnd, -1, NULL );
		break;

	case IDM_NTPSERVER:
		{
			TCHAR		szMsg[256];
			TCHAR		szServer[64], *p;
			SHORT		nPort;
			SYSTEMTIME	tmServer, tmLocal;
			lstrcpy( szServer, g_tTryIcon.szNTP );
			if( p = lstrrchr(szServer,':') )
			{
				*p = '\0';
				nPort = lston( p+1 );
			}
			if( GetServerTime( &tmServer, szServer, nPort ) == -1 )
			{
				DisplayMessage( GetString(IDS_NTPERR) );
				break;
			}
			GetLocalTime( &tmLocal );
			SetLocalTime( &tmServer );
			wsprintf( szMsg, GetString(IDS_NTPMSG),
				tmServer.wYear,tmServer.wMonth,tmServer.wDay, tmServer.wHour,tmServer.wMinute,tmServer.wSecond,tmServer.wMilliseconds,
				tmLocal.wYear,tmLocal.wMonth,tmLocal.wDay, tmLocal.wHour,tmLocal.wMinute,tmLocal.wSecond,tmLocal.wMilliseconds );
			DisplayMessage( szMsg );
		}
		break;
	case IDM_SCRNSAVE:
		Sleep( 500 );
		PostMessage( hWnd, WM_SYSCOMMAND, SC_SCREENSAVE, 0 );
		break;
	}

	return	TRUE;
}
//
BOOL HookIconTray( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case	WM_CREATE:
		nid.cbSize			= sizeof(NOTIFYICONDATA);
		nid.uID				= 1;
		nid.hWnd			= hWnd;
		nid.uFlags			= NIF_ICON | NIF_MESSAGE | NIF_TIP;
		nid.hIcon			= LoadIcon( g_hInst, MAKEINTRESOURCE(IDI_MAIN) );
		nid.uCallbackMessage= WM_TASKTRAY;
		lstrcpy( nid.szTip, APPNAME );
		if( Shell_NotifyIcon( NIM_ADD, &nid ) )
		{
			hImgClk	= ImageList_LoadBitmap( g_hInst, MAKEINTRESOURCE(IDB_CLOCK), 16, 0, RGB(0,0,0) );
			hImgCpu	= ImageList_LoadBitmap( g_hInst, MAKEINTRESOURCE(IDB_CPU  ), 16, 0, RGB(0,0,0) );
			hMenu	= LoadMenu( g_hInst, MAKEINTRESOURCE(IDR_TRAYMENU) );
			hMenu	= GetSubMenu( hMenu, 0 );
			InitCpuUsage();
			HookIconTrayTimer( hWnd, -1, NULL );
		}
		return	TRUE;

	case	WM_DESTROY:
		if( Shell_NotifyIcon( NIM_DELETE, &nid ) )
		{
			ExitCpuUsage();
			DestroyMenu( hMenu );
			ImageList_Destroy( hImgCpu );
			ImageList_Destroy( hImgClk );
		}
		return	TRUE;

	case	WM_TIMER:
		return	HookIconTrayTimer( hWnd, (UINT)wParam, (TIMERPROC *)lParam );

	case	WM_TASKTRAY:
		return	HookIconTrayTaskTray( hWnd, (UINT)wParam, (UINT)lParam );

	case	WM_COMMAND:
		return	HookIconTrayCommand( hWnd, HIWORD(wParam), LOWORD(wParam), (HWND)lParam );
	}

	return	FALSE;
}


////////////////////////////////////////////////////////////
//	C֐

//^C}[̒
BOOL AdjustTimer( HWND hWnd )
{
	GetLocalTime( &g_tTime );

	if( 50 < g_tTime.wMilliseconds && g_tTime.wMilliseconds < 950 )
	{
		KillTimer( hWnd, 0 );
		Sleep( 1000 - g_tTime.wMilliseconds );
		SetTimer( hWnd, 0, 1000, NULL );
		GetLocalTime( &g_tTime );

		return	TRUE;
	}
	return	FALSE;
}

//GNX|[g
BOOL SetExeHook( BOOL bEnable, TOPTION* pOption )
{
	if( pOption != NULL )
	{
		g_tTryIcon	= pOption->tTryIcon;
		g_tTryAlrm	= pOption->tTryAlrm;
	}

	return	TRUE;
}

//CEBhE
LRESULT CALLBACK MainWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	BOOL	bReturn	= FALSE;

	switch( uMsg )
	{
	case	WM_CREATE:
		{
			TOPTION	tOption;
			ReadOption( &tOption );
			SetExeHook( TRUE, &tOption );
			SetDllHook( TRUE, &tOption );
			SetTimer( hWnd, 0, 1000, NULL );
		}
		bReturn	= TRUE;
		break;

	case	WM_CLOSE:
		DestroyWindow( hWnd );
		bReturn	= TRUE;
		break;
	case	WM_DESTROY:
		KillTimer( hWnd, 0 );
		SetExeHook( FALSE, NULL );
		SetDllHook( FALSE, NULL );
		PostQuitMessage( 0 );
		bReturn	= TRUE;
		break;

	case	WM_TIMER:
		AdjustTimer( hWnd );
		bReturn	= TRUE;
		break;
	}

	if( g_tTryIcon.bEnable )	bReturn |= HookIconTray( hWnd, uMsg, wParam, lParam );

	if( bReturn )
		return	0;
	else
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

//C֐
int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow )
{
	HWND		hWnd;
	MSG			msg;
	WNDCLASS	wc;

	if( FindWindow( CLASSNAME, APPNAME ) )
		return	0;

	g_hInst = hInst;
	InitCommonControls();

	ZeroMemory( &wc, sizeof(WNDCLASS) );
	wc.hInstance	= hInst;
	wc.lpfnWndProc	= MainWndProc;
	wc.lpszClassName= CLASSNAME;
	if( RegisterClass(&wc) == 0 )
		return	0;

	hWnd = CreateWindow( CLASSNAME, APPNAME, WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
						NULL, NULL, hInst, NULL );
	if( hWnd == NULL )
		return	0;

	ShowWindow( hWnd, SW_HIDE );	//SW_SHOW
	UpdateWindow( hWnd );

	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	return	msg.wParam;
}
//
void __cdecl WinMainCRTStartup( void )
{
	ExitProcess( WinMain( GetModuleHandle(NULL), NULL, NULL, SW_SHOWDEFAULT ) );
}
