/////////////////////////////////////////////////////////////////////////////
//		util.h

#ifndef __UTIL_H__
#define __UTIL_H__


#ifdef __cplusplus
extern "C" {
#endif


#pragma	warning(disable: 4005)	//}NĒ`


// }N`
#define	WM_MOUSEWHEEL					0x020A
#define	MOD_WIN							0x0008
#define	BIF_EDITBOX						0x0010
#define	OFN_ENABLESIZING		 		0x00800000
#define	SPI_GETFOREGROUNDLOCKTIMEOUT	0x2000
#define	SPI_SETFOREGROUNDLOCKTIMEOUT	0x2001
#define	BM_GETVKEY						(WM_USER+0x4000)
#define	BM_SETVKEY						(WM_USER+0x4001)
#define	_T(quote)						__TEXT(quote)

// QWORD^
typedef	unsigned __int64				QWORD;
#define	MAKEQWORD(a,b)					(QWORD)( (QWORD)(a) | (QWORD)(b) << 32 )
#define	LODWORD(q)						(DWORD)(q)
#define HIDWORD(q)						(DWORD)((q) >> 32 & 0xFFFFFFFF)


// }N֐
#ifdef __cplusplus
template <class T> inline void swap(T& a, T&b)									{ T x=a; b=a; a=x; }

// caseof
template <class T> inline int caseof(T x, T a)									{ return (x==a ? 1 : 0); }
template <class T> inline int caseof(T x, T a, T b)								{ return (x==b ? 2 : caseof(x,a)); }
template <class T> inline int caseof(T x, T a, T b, T c)						{ return (x==c ? 3 : caseof(x,a,b)); }
template <class T> inline int caseof(T x, T a, T b, T c, T d)					{ return (x==d ? 4 : caseof(x,a,b,c)); }
template <class T> inline int caseof(T x, T a, T b, T c, T d, T e)				{ return (x==e ? 5 : caseof(x,a,b,c,d)); }
template <class T> inline int caseof(T x, T a, T b, T c, T d, T e, T f)			{ return (x==f ? 6 : caseof(x,a,b,c,d,e)); }
template <class T> inline int caseof(T x, T a, T b, T c, T d, T e, T f, T g)	{ return (x==g ? 7 : caseof(x,a,b,c,d,e,f)); }
#endif


#pragma	warning(default: 4005)


// f[^ϊ
INT lston( LPCTSTR );
LPTSTR lntos( INT, LPTSTR );

// 񑀍
LPTSTR lstrchr( LPCTSTR, TCHAR );
LPTSTR lstrrchr( LPCTSTR, TCHAR );
LPTSTR lstrstr( LPCTSTR, LPCTSTR );
LPTSTR lstrstri( LPCTSTR, LPCTSTR );
LPTSTR lstrend( LPCTSTR );
INT lstrcmpn( LPCTSTR, LPCTSTR, INT );
INT lstrchk( LPCTSTR, LPCTSTR );
INT lstrchki( LPCTSTR, LPCTSTR );
INT IsLegal( LPCTSTR );

// ݒt@C
#define DeletePrivateProfileSection(sec,fil) WritePrivateProfileSection(sec,NULL,fil)
#define DeletePrivateProfileString(sec,key,fil) WritePrivateProfileString(sec,key,NULL,fil)
BOOL WritePrivateProfileInt( LPCTSTR, LPCTSTR, INT, LPCTSTR );

// WXg
HKEY RegKeyOpen( HKEY, LPCTSTR );
HKEY RegKeyCreate( HKEY, LPCTSTR );
VOID RegKeyClose( HKEY );
BOOL RegKeyDelete( HKEY, LPCTSTR );
BOOL RegKeyForceDelete( HKEY, LPCTSTR );
DWORD RegGetNumber( HKEY, LPCTSTR );
VOID RegSetNumber( HKEY, LPCTSTR, DWORD );
DWORD RegGetString( HKEY, LPCTSTR, LPTSTR, DWORD );
VOID RegSetString( HKEY, LPCTSTR, LPCTSTR );
DWORD RegGetBinary( HKEY, LPCTSTR, LPVOID, DWORD );
VOID RegSetBinary( HKEY, LPCTSTR, LPVOID, DWORD );
VOID RegDelValue( HKEY, LPCTSTR );

// EBhE
#define IsWindowActive(wnd) ( wnd==GetActiveWindow() )
#define IsWindowForeground(wnd) ( wnd==GetForegroundWindow() )
BOOL SetForegroundWindowEx( HWND );
BOOL GetWindowBaseName( HWND, LPTSTR, DWORD );
HWND GetDescendantWindow( HWND, INT );
HWND GetBaseWindow( HWND );
void GetFrameSize( HWND, SIZE * );
void GetCaptionRect( HWND, RECT * );

// _CAO
#define SetDlgItemCheck(dlg,itm,chk) SendDlgItemMessage(dlg,itm,BM_SETCHECK,chk,0)
#define GetDlgItemCheck(dlg,itm) SendDlgItemMessage(dlg,itm,BM_GETCHECK,0,0)
#define SetDlgItemVKey(dlg,itm,key) SendDlgItemMessage(dlg,itm,BM_SETVKEY,key,0)
#define GetDlgItemVKey(dlg,itm) SendDlgItemMessage(dlg,itm,BM_GETVKEY,0,0)
VOID InitKeyScanButton( HWND );

// ʃ_CAO
DWORD SaveDialogBox( LPTSTR, LPCTSTR );
DWORD OpenDialogBox( LPTSTR, LPCTSTR );
BOOL IconDialogBox( LPTSTR, INT * );
BOOL FolderDialogBox( LPTSTR, LPCTSTR );

// ̑
HBITMAP LoadClippedBitmap( HINSTANCE, LPCTSTR, RECT );
BOOL ReadFileLine( HANDLE, LPTSTR, DWORD, LPDWORD );
BOOL ForceCreateDirectory( LPCTSTR, LPSECURITY_ATTRIBUTES );
BOOL ForceRemoveDirectory( LPCTSTR );
DWORD FreeMemory( void );
BOOL ProcessMessage( HWND, UINT, UINT );
#define	DoEvents() while( ProcessMessage(NULL,0,0) );


#ifdef __cplusplus
}	//extern "C"
#endif


#endif	//__UTIL_H__