/////////////////////////////////////////////////////////////////////////////
//		TrUtlDll.c

#include	<windows.h>
#include	"TrUtl.h"
#include	"util.h"


/////////////////////////////////////////////////////////
//	錾

#pragma data_seg(".sdata")

//ϐ
HINSTANCE	g_hInst		= NULL;
HHOOK		g_hHookWnd	= NULL;
HHOOK		g_hHookMsg	= NULL;
TWNDGRID	g_tWndGrid	= {0};
TMOUSCRL	g_tMouScrl	= {0};
TSELTASK	g_tSelTask	= {0};


////////////////////////////////////////////////////////////
//	EBhËʒu

//萔
#define		WMSZ_MOVE	0

//ϐ
WNDPROC		pSubProc	= NULL;
POINT		ptCur		= {0};
RECT		rcWnd		= {0};
RECT		rcTop		= {0};

//EBhE̒
VOID FormWnd( UINT nSide, LPRECT lpRect )
{
	POINT	pt;
	GetCursorPos( &pt );

	//ύX
	pt.x -= ptCur.x;
	pt.y -= ptCur.y;

	//Ȃ
	if( GetKeyState(g_tWndGrid.nPauseKey) & 0x8000 )
		goto FormWnd_Move;

	//XύX
	if( nSide==WMSZ_MOVE )
	{
		if     ( pt.x == 0 )
			;
		else if( abs( rcWnd.left   + pt.x - rcTop.left   ) < (g_tWndGrid.nInterval/2) )
			pt.x  = rcTop.left   - rcWnd.left;
		else if( abs( rcWnd.right  + pt.x - rcTop.right  ) < (g_tWndGrid.nInterval/2) )
			pt.x  = rcTop.right  - rcWnd.right;
		else
			pt.x -= (pt.x+rcWnd.left   + (g_tWndGrid.nInterval/2)) % g_tWndGrid.nInterval - (g_tWndGrid.nInterval/2);
	}
	if( nSide==WMSZ_TOPLEFT    || nSide==WMSZ_LEFT   || nSide==WMSZ_BOTTOMLEFT  )
	{
		if     ( pt.x == 0 )
			;
		else if( abs( rcWnd.left   + pt.x - rcTop.left   ) < (g_tWndGrid.nInterval/2) )
			pt.x  = rcTop.left   - rcWnd.left;
		else
			pt.x -= (pt.x+rcWnd.left   + (g_tWndGrid.nInterval/2)) % g_tWndGrid.nInterval - (g_tWndGrid.nInterval/2);
	}
	if( nSide==WMSZ_TOPRIGHT   || nSide==WMSZ_RIGHT  || nSide==WMSZ_BOTTOMRIGHT )
	{
		if     ( pt.x == 0 )
			;
		else if( abs( rcWnd.right  + pt.x - rcTop.right  ) < (g_tWndGrid.nInterval/2) )
			pt.x  = rcTop.right  - rcWnd.right;
		else
			pt.x -= (pt.x+rcWnd.right  + (g_tWndGrid.nInterval/2)) % g_tWndGrid.nInterval - (g_tWndGrid.nInterval/2);
	}

	//YύX
	if( nSide==WMSZ_MOVE )
	{
		if( pt.y == 0 )
			;
  		else if( abs( rcWnd.top    + pt.y - rcTop.top    ) < (g_tWndGrid.nInterval/2) )
			pt.y = rcTop.top    - rcWnd.top;
		else if( abs( rcWnd.bottom + pt.y - rcTop.bottom ) < (g_tWndGrid.nInterval/2) )
			pt.y = rcTop.bottom - rcWnd.bottom;
		else
			pt.y -= (pt.y+rcWnd.top + (g_tWndGrid.nInterval/2)) % g_tWndGrid.nInterval - (g_tWndGrid.nInterval/2);
	}
	if( nSide==WMSZ_TOPLEFT    || nSide==WMSZ_TOP    || nSide==WMSZ_TOPRIGHT    )
	{
		if( pt.y == 0 )
			;
  		else if( abs( rcWnd.top    + pt.y - rcTop.top    ) < (g_tWndGrid.nInterval/2) )
			pt.y = rcTop.top    - rcWnd.top;
		else
			pt.y -= (pt.y+rcWnd.top    + (g_tWndGrid.nInterval/2)) % g_tWndGrid.nInterval - (g_tWndGrid.nInterval/2);
	}
	if( nSide==WMSZ_BOTTOMLEFT || nSide==WMSZ_BOTTOM || nSide==WMSZ_BOTTOMRIGHT )
	{
		if( pt.y == 0 )
			;
		else if( abs( rcWnd.bottom + pt.y - rcTop.bottom ) < (g_tWndGrid.nInterval/2) )
			pt.y = rcTop.bottom - rcWnd.bottom;
		else
			pt.y -= (pt.y+rcWnd.bottom + (g_tWndGrid.nInterval/2)) % g_tWndGrid.nInterval - (g_tWndGrid.nInterval/2);
	}

FormWnd_Move:
	//ړ
	if( nSide==WMSZ_TOPLEFT    || nSide==WMSZ_LEFT   || nSide==WMSZ_BOTTOMLEFT  || nSide==WMSZ_MOVE )
		lpRect->left   = rcWnd.left   + pt.x;
	if( nSide==WMSZ_TOPLEFT    || nSide==WMSZ_TOP    || nSide==WMSZ_TOPRIGHT    || nSide==WMSZ_MOVE )
		lpRect->top    = rcWnd.top    + pt.y;
	if( nSide==WMSZ_TOPRIGHT   || nSide==WMSZ_RIGHT  || nSide==WMSZ_BOTTOMRIGHT || nSide==WMSZ_MOVE )
		lpRect->right  = rcWnd.right  + pt.x;
	if( nSide==WMSZ_BOTTOMLEFT || nSide==WMSZ_BOTTOM || nSide==WMSZ_BOTTOMRIGHT || nSide==WMSZ_MOVE )
		lpRect->bottom = rcWnd.bottom + pt.y;
}

//TuvV[W[
LRESULT CALLBACK SubWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch ( uMsg )
	{
	case	WM_ENTERSIZEMOVE:
		GetCursorPos( &ptCur );
		GetWindowRect( hWnd, &rcWnd );

		if( ~GetWindowLong(hWnd,GWL_EXSTYLE) & WS_EX_MDICHILD )
			SystemParametersInfo( SPI_GETWORKAREA, 0, &rcTop, 0 ); 
		else
		{
			HWND	hPWnd	= GetParent( hWnd );
			POINT	pt		= {0};
			GetClientRect( hPWnd, &rcTop );
			ClientToScreen( hPWnd, &pt );
			rcTop.left  += pt.x;	rcTop.top    += pt.y;
			rcTop.right += pt.x;	rcTop.bottom += pt.y;
		}
    	break;

	case	WM_MOVING:
		FormWnd( WMSZ_MOVE, (LPRECT)lParam );
		break;

	case	WM_SIZING:
		FormWnd( wParam, (LPRECT)lParam );
		break;
	}

	return	CallWindowProc( pSubProc, hWnd, uMsg, wParam, lParam );
}

//tbN
BOOL HookWindowGrid( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case	WM_ENTERSIZEMOVE:
		if( ! pSubProc )	pSubProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)SubWndProc );
		break;

	case	WM_EXITSIZEMOVE:
		if( pSubProc )		SetWindowLong( hWnd, GWL_WNDPROC, (LONG)pSubProc ),	pSubProc = NULL;
		break;
	}

	return	TRUE;
}


////////////////////////////////////////////////////////////
//	}EXɂXN[

//ϐ
POINT		ptOld		= {0};
POINT		ptDiff		= {0};

//tbN
BOOL HookMouseScroll( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case	WM_MOUSEMOVE:
		{
			POINT	pt;
			GetCursorPos( &pt );
			if( ptOld.x == pt.x && ptOld.y == pt.y )
				break;
			if( GetKeyState(g_tMouScrl.nPlayKey) & 0x8000 && pSubProc == NULL )
			{
				ptDiff.x += pt.x - ptOld.x;
				ptDiff.y += pt.y - ptOld.y;
				SetCursorPos( ptOld.x, ptOld.y );

				if( ptDiff.x <= -g_tMouScrl.nSense )	ptDiff.x += g_tMouScrl.nSense, PostMessage( hWnd, WM_HSCROLL, SB_LINEUP  , 0 );
				if( ptDiff.x >=  g_tMouScrl.nSense )	ptDiff.x -= g_tMouScrl.nSense, PostMessage( hWnd, WM_HSCROLL, SB_LINEDOWN, 0 );
				if( ptDiff.y <= -g_tMouScrl.nSense )	ptDiff.y += g_tMouScrl.nSense, PostMessage( hWnd, WM_VSCROLL, SB_LINEUP  , 0 );
				if( ptDiff.y >=  g_tMouScrl.nSense )	ptDiff.y -= g_tMouScrl.nSense, PostMessage( hWnd, WM_VSCROLL, SB_LINEDOWN, 0 );
			}
			else
			{
				ptOld = pt;
				ptDiff.x = ptDiff.y = 0;
			}
		}
		break;
	}

	return	TRUE;
}


////////////////////////////////////////////////////////////
//	^XNI

//tbN
BOOL HookSelectTask( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( uMsg == WM_NCMBUTTONUP && wParam == HTCAPTION )
	{
		HMENU	hMenu;
		HWND	hWnd2;
		TCHAR	szImage[MAX_PATH];
		TCHAR	szBuf[MAX_PATH];
		RECT	rc;
		LONG	lStyle;

		hMenu = CreatePopupMenu();
		InsertMenu( hMenu, 0, MF_BYPOSITION|MF_SEPARATOR, 0, NULL );
		GetWindowBaseName( hWnd, szImage, MAX_PATH );

		hWnd2 = GetWindow( hWnd, GW_HWNDLAST );
		do {
			GetWindowRect( hWnd2, &rc );
			if( ! IsWindowVisible( hWnd2 )
			||	( rc.left == rc.right || rc.top == rc.bottom ) ) {
				continue;
			}

			GetClassName( hWnd2, szBuf, MAX_PATH );
			if( lstrcmp( szBuf, _T("Progman")       ) == 0
			||	lstrcmp( szBuf, _T("Shell_TrayWnd") ) == 0 ) {
				continue;
			}

			if( GetWindow( hWnd2, GW_OWNER ) != NULL ) {
				continue;
			}

			if( ! g_tSelTask.bToolWnd ) {
				lStyle = GetWindowLong( hWnd2, GWL_EXSTYLE );
				if( lStyle & WS_EX_TOOLWINDOW ) {
					continue;
				}
			}

			GetWindowBaseName( hWnd2, szBuf, MAX_PATH );
			if( lstrcmp( szBuf, szImage ) == 0 )
			{
				GetWindowText( hWnd2, szBuf, MAX_PATH );
				if( hWnd == hWnd2 ) {
					InsertMenu( hMenu,  0, MF_BYPOSITION|MF_STRING|MF_CHECKED, (UINT)hWnd2, szBuf );
				} else {
					InsertMenu( hMenu,  0, MF_BYPOSITION|MF_STRING, (UINT)hWnd2, szBuf );
				}
			}
			else
			{
				GetWindowText( hWnd2, szBuf, MAX_PATH );
				InsertMenu( hMenu, -1, MF_BYPOSITION|MF_STRING, (UINT)hWnd2, szBuf );
			}
		}
		while( hWnd2 = GetWindow(hWnd2,GW_HWNDPREV) );

		hWnd2 = (HWND)TrackPopupMenuEx( hMenu, TPM_LEFTALIGN|TPM_VERTICAL|TPM_NONOTIFY|TPM_RETURNCMD|TPM_RIGHTBUTTON, LOWORD(lParam), HIWORD(lParam), hWnd, NULL );
		DestroyMenu( hMenu );

		if( hWnd2 && IsWindow(hWnd2) )
		{
			if( IsZoomed(hWnd2) ) {
				ShowWindow( hWnd2, SW_SHOW );
			} else {
				ShowWindow( hWnd2, SW_RESTORE );
			}
			SetForegroundWindow( hWnd2 );
		}
	}

	return	TRUE;
}


////////////////////////////////////////////////////////////
//	C֐

//tbNvV[W[
BOOL HookProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	BOOL	bResult = TRUE;
	if( g_tWndGrid.bEnable )	bResult &= HookWindowGrid  ( hWnd, uMsg, wParam, lParam );
	if( g_tMouScrl.bEnable )	bResult &= HookMouseScroll ( hWnd, uMsg, wParam, lParam );
	if( g_tSelTask.bEnable )	bResult &= HookSelectTask  ( hWnd, uMsg, wParam, lParam );
	return	bResult;
}
LRESULT CALLBACK CallWndProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	if( nCode == HC_ACTION )
	{
		CWPSTRUCT*	cwps	= (CWPSTRUCT*)lParam;
		if( ! HookProc( cwps->hwnd, cwps->message, cwps->wParam, cwps->lParam ) )
			cwps->message = WM_NULL;
	}
	return	CallNextHookEx( g_hHookWnd, nCode, wParam, lParam );
}
LRESULT CALLBACK GetMsgProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	if( nCode == HC_ACTION )
	{
		MSG*		lpMsg	= (MSG*)lParam;
		if( ! HookProc( lpMsg->hwnd, lpMsg->message, lpMsg->wParam, lpMsg->lParam ) )
			lpMsg->message = WM_NULL;
	}
	return	CallNextHookEx( g_hHookMsg, nCode, wParam, lParam );
}

//GNX|[g
BOOL SetDllHook( BOOL bEnable, TOPTION* pOption )
{
	if( pOption != NULL )
	{
		g_tWndGrid	= pOption->tWndGrid;
		g_tMouScrl	= pOption->tMouScrl;
		g_tSelTask	= pOption->tSelTask;
	}

	if( bEnable )
	{
		if( ! g_hHookWnd )	g_hHookWnd	= SetWindowsHookEx( WH_CALLWNDPROC, (HOOKPROC)CallWndProc, g_hInst, 0 );
		if( ! g_hHookMsg )	g_hHookMsg	= SetWindowsHookEx( WH_GETMESSAGE , (HOOKPROC)GetMsgProc , g_hInst, 0 );
	}
	else
	{
		if( g_hHookWnd )	UnhookWindowsHookEx( g_hHookWnd ),	g_hHookWnd = NULL;
		if( g_hHookMsg )	UnhookWindowsHookEx( g_hHookMsg ),	g_hHookMsg = NULL;
	}

	return	TRUE;
}

//C֐
BOOL WINAPI DllMain( HINSTANCE hInst, DWORD dwReason, LPVOID lpReserved )
{
	if( dwReason == DLL_PROCESS_ATTACH )
		g_hInst	= hInst;

	return	TRUE;
}
//
BOOL WINAPI _DllMainCRTStartup( HINSTANCE hInst, DWORD dwReason, LPVOID lpReserved )
{
	return	DllMain( hInst, dwReason, lpReserved );
}